Loading...
Searching...
No Matches
cipher.h File Reference

This file contains an abstraction interface for use with the cipher primitives provided by the library. It provides a common interface to all of the available cipher operations. More...

`#include "mbedtls/private_access.h"`
`#include "mbedtls/build_info.h"`
`#include <stddef.h>`
`#include "mbedtls/platform_util.h"`
Include dependency graph for cipher.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | mbedtls_cipher_info_t
struct | mbedtls_cipher_context_t

## Macros

#define | MBEDTLS_CIPHER_MODE_AEAD
#define | MBEDTLS_CIPHER_MODE_WITH_PADDING
#define | MBEDTLS_CIPHER_MODE_STREAM
#define | MBEDTLS_ERR_CIPHER_FEATURE_UNAVAILABLE -0x6080
#define | MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA -0x6100
#define | MBEDTLS_ERR_CIPHER_ALLOC_FAILED -0x6180
#define | MBEDTLS_ERR_CIPHER_INVALID_PADDING -0x6200
#define | MBEDTLS_ERR_CIPHER_FULL_BLOCK_EXPECTED -0x6280
#define | MBEDTLS_ERR_CIPHER_AUTH_FAILED -0x6300
#define | MBEDTLS_ERR_CIPHER_INVALID_CONTEXT -0x6380
#define | MBEDTLS_CIPHER_VARIABLE_IV_LEN 0x01
#define | MBEDTLS_CIPHER_VARIABLE_KEY_LEN 0x02
#define | MBEDTLS_MAX_IV_LENGTH 16
#define | MBEDTLS_MAX_BLOCK_LENGTH 16
#define | MBEDTLS_MAX_KEY_LENGTH 64
#define | MBEDTLS_KEY_BITLEN_SHIFT 6
#define | MBEDTLS_IV_SIZE_SHIFT 2

## Typedefs

typedef struct mbedtls_cipher_base_t | mbedtls_cipher_base_t
typedef struct mbedtls_cmac_context_t | mbedtls_cmac_context_t
typedef struct mbedtls_cipher_info_t | mbedtls_cipher_info_t
typedef struct mbedtls_cipher_context_t | mbedtls_cipher_context_t

## Enumerations

enum | mbedtls_cipher_id_t { MBEDTLS_CIPHER_ID_NONE = 0 , MBEDTLS_CIPHER_ID_NULL , MBEDTLS_CIPHER_ID_AES , MBEDTLS_CIPHER_ID_DES , MBEDTLS_CIPHER_ID_3DES , MBEDTLS_CIPHER_ID_CAMELLIA , MBEDTLS_CIPHER_ID_ARIA , MBEDTLS_CIPHER_ID_CHACHA20 }
| Supported cipher types. More...

enum

mbedtls_cipher_type_t {
MBEDTLS_CIPHER_NONE = 0 , MBEDTLS_CIPHER_NULL , MBEDTLS_CIPHER_AES_128_ECB , MBEDTLS_CIPHER_AES_192_ECB ,
MBEDTLS_CIPHER_AES_256_ECB , MBEDTLS_CIPHER_AES_128_CBC , MBEDTLS_CIPHER_AES_192_CBC , MBEDTLS_CIPHER_AES_256_CBC ,
MBEDTLS_CIPHER_AES_128_CFB128 , MBEDTLS_CIPHER_AES_192_CFB128 , MBEDTLS_CIPHER_AES_256_CFB128 , MBEDTLS_CIPHER_AES_128_CTR ,
MBEDTLS_CIPHER_AES_192_CTR , MBEDTLS_CIPHER_AES_256_CTR , MBEDTLS_CIPHER_AES_128_GCM , MBEDTLS_CIPHER_AES_192_GCM ,
MBEDTLS_CIPHER_AES_256_GCM , MBEDTLS_CIPHER_CAMELLIA_128_ECB , MBEDTLS_CIPHER_CAMELLIA_192_ECB , MBEDTLS_CIPHER_CAMELLIA_256_ECB ,
MBEDTLS_CIPHER_CAMELLIA_128_CBC , MBEDTLS_CIPHER_CAMELLIA_192_CBC , MBEDTLS_CIPHER_CAMELLIA_256_CBC , MBEDTLS_CIPHER_CAMELLIA_128_CFB128 ,
MBEDTLS_CIPHER_CAMELLIA_192_CFB128 , MBEDTLS_CIPHER_CAMELLIA_256_CFB128 , MBEDTLS_CIPHER_CAMELLIA_128_CTR , MBEDTLS_CIPHER_CAMELLIA_192_CTR ,
MBEDTLS_CIPHER_CAMELLIA_256_CTR , MBEDTLS_CIPHER_CAMELLIA_128_GCM , MBEDTLS_CIPHER_CAMELLIA_192_GCM , MBEDTLS_CIPHER_CAMELLIA_256_GCM ,
MBEDTLS_CIPHER_DES_ECB , MBEDTLS_CIPHER_DES_CBC , MBEDTLS_CIPHER_DES_EDE_ECB , MBEDTLS_CIPHER_DES_EDE_CBC ,
MBEDTLS_CIPHER_DES_EDE3_ECB , MBEDTLS_CIPHER_DES_EDE3_CBC , MBEDTLS_CIPHER_AES_128_CCM , MBEDTLS_CIPHER_AES_192_CCM ,
MBEDTLS_CIPHER_AES_256_CCM , MBEDTLS_CIPHER_AES_128_CCM_STAR_NO_TAG , MBEDTLS_CIPHER_AES_192_CCM_STAR_NO_TAG , MBEDTLS_CIPHER_AES_256_CCM_STAR_NO_TAG ,
MBEDTLS_CIPHER_CAMELLIA_128_CCM , MBEDTLS_CIPHER_CAMELLIA_192_CCM , MBEDTLS_CIPHER_CAMELLIA_256_CCM , MBEDTLS_CIPHER_CAMELLIA_128_CCM_STAR_NO_TAG ,
MBEDTLS_CIPHER_CAMELLIA_192_CCM_STAR_NO_TAG , MBEDTLS_CIPHER_CAMELLIA_256_CCM_STAR_NO_TAG , MBEDTLS_CIPHER_ARIA_128_ECB , MBEDTLS_CIPHER_ARIA_192_ECB ,
MBEDTLS_CIPHER_ARIA_256_ECB , MBEDTLS_CIPHER_ARIA_128_CBC , MBEDTLS_CIPHER_ARIA_192_CBC , MBEDTLS_CIPHER_ARIA_256_CBC ,
MBEDTLS_CIPHER_ARIA_128_CFB128 , MBEDTLS_CIPHER_ARIA_192_CFB128 , MBEDTLS_CIPHER_ARIA_256_CFB128 , MBEDTLS_CIPHER_ARIA_128_CTR ,
MBEDTLS_CIPHER_ARIA_192_CTR , MBEDTLS_CIPHER_ARIA_256_CTR , MBEDTLS_CIPHER_ARIA_128_GCM , MBEDTLS_CIPHER_ARIA_192_GCM ,
MBEDTLS_CIPHER_ARIA_256_GCM , MBEDTLS_CIPHER_ARIA_128_CCM , MBEDTLS_CIPHER_ARIA_192_CCM , MBEDTLS_CIPHER_ARIA_256_CCM ,
MBEDTLS_CIPHER_ARIA_128_CCM_STAR_NO_TAG , MBEDTLS_CIPHER_ARIA_192_CCM_STAR_NO_TAG , MBEDTLS_CIPHER_ARIA_256_CCM_STAR_NO_TAG , MBEDTLS_CIPHER_AES_128_OFB ,
MBEDTLS_CIPHER_AES_192_OFB , MBEDTLS_CIPHER_AES_256_OFB , MBEDTLS_CIPHER_AES_128_XTS , MBEDTLS_CIPHER_AES_256_XTS ,
MBEDTLS_CIPHER_CHACHA20 , MBEDTLS_CIPHER_CHACHA20_POLY1305 , MBEDTLS_CIPHER_AES_128_KW , MBEDTLS_CIPHER_AES_192_KW ,
MBEDTLS_CIPHER_AES_256_KW , MBEDTLS_CIPHER_AES_128_KWP , MBEDTLS_CIPHER_AES_192_KWP , MBEDTLS_CIPHER_AES_256_KWP
}

| Supported {cipher type, cipher mode} pairs. More...
enum | mbedtls_cipher_mode_t { MBEDTLS_MODE_NONE = 0 , MBEDTLS_MODE_ECB , MBEDTLS_MODE_CBC , MBEDTLS_MODE_CFB , MBEDTLS_MODE_OFB , MBEDTLS_MODE_CTR , MBEDTLS_MODE_GCM , MBEDTLS_MODE_STREAM , MBEDTLS_MODE_CCM , MBEDTLS_MODE_CCM_STAR_NO_TAG , MBEDTLS_MODE_XTS , MBEDTLS_MODE_CHACHAPOLY , MBEDTLS_MODE_KW , MBEDTLS_MODE_KWP }
enum | mbedtls_cipher_padding_t { MBEDTLS_PADDING_PKCS7 = 0 , MBEDTLS_PADDING_ONE_AND_ZEROS , MBEDTLS_PADDING_ZEROS_AND_LEN , MBEDTLS_PADDING_ZEROS , MBEDTLS_PADDING_NONE }
enum | mbedtls_operation_t { MBEDTLS_OPERATION_NONE = -1 , MBEDTLS_DECRYPT = 0 , MBEDTLS_ENCRYPT }
enum | { MBEDTLS_KEY_LENGTH_NONE = 0 , MBEDTLS_KEY_LENGTH_DES = 64 , MBEDTLS_KEY_LENGTH_DES_EDE = 128 , MBEDTLS_KEY_LENGTH_DES_EDE3 = 192 }

## Functions

const int * | mbedtls_cipher_list (void)
| This function retrieves the list of ciphers supported by the generic cipher module.
const mbedtls_cipher_info_t * | mbedtls_cipher_info_from_string (const char *cipher_name)
| This function retrieves the cipher-information structure associated with the given cipher name.
const mbedtls_cipher_info_t * | mbedtls_cipher_info_from_type (const mbedtls_cipher_type_t cipher_type)
| This function retrieves the cipher-information structure associated with the given cipher type.
const mbedtls_cipher_info_t * | mbedtls_cipher_info_from_values (const mbedtls_cipher_id_t cipher_id, int key_bitlen, const mbedtls_cipher_mode_t mode)
| This function retrieves the cipher-information structure associated with the given cipher ID, key size and mode.
static mbedtls_cipher_type_t | mbedtls_cipher_info_get_type (const mbedtls_cipher_info_t *info)
| Retrieve the identifier for a cipher info structure.
static mbedtls_cipher_mode_t | mbedtls_cipher_info_get_mode (const mbedtls_cipher_info_t *info)
| Retrieve the operation mode for a cipher info structure.
static size_t | mbedtls_cipher_info_get_key_bitlen (const mbedtls_cipher_info_t *info)
| Retrieve the key size for a cipher info structure.
static const char * | mbedtls_cipher_info_get_name (const mbedtls_cipher_info_t *info)
| Retrieve the human-readable name for a cipher info structure.
static size_t | mbedtls_cipher_info_get_iv_size (const mbedtls_cipher_info_t *info)
| This function returns the size of the IV or nonce for the cipher info structure, in bytes.
static size_t | mbedtls_cipher_info_get_block_size (const mbedtls_cipher_info_t *info)
| This function returns the block size of the given cipher info structure in bytes.
static int | mbedtls_cipher_info_has_variable_key_bitlen (const mbedtls_cipher_info_t *info)
| This function returns a non-zero value if the key length for the given cipher is variable.
static int | mbedtls_cipher_info_has_variable_iv_size (const mbedtls_cipher_info_t *info)
| This function returns a non-zero value if the IV size for the given cipher is variable.
void | mbedtls_cipher_init (mbedtls_cipher_context_t *ctx)
| This function initializes a `ctx` as NONE.
void | mbedtls_cipher_free (mbedtls_cipher_context_t *ctx)
| This function frees and clears the cipher-specific context of `ctx`. Freeing `ctx` itself remains the responsibility of the caller.
int | mbedtls_cipher_setup (mbedtls_cipher_context_t *ctx, const mbedtls_cipher_info_t *cipher_info)
| This function prepares a cipher context for use with the given cipher primitive.
static unsigned int | mbedtls_cipher_get_block_size (const mbedtls_cipher_context_t *ctx)
| This function returns the block size of the given cipher in bytes.
static mbedtls_cipher_mode_t | mbedtls_cipher_get_cipher_mode (const mbedtls_cipher_context_t *ctx)
| This function returns the mode of operation for the cipher. For example, MBEDTLS_MODE_CBC.
static int | mbedtls_cipher_get_iv_size (const mbedtls_cipher_context_t *ctx)
| This function returns the size of the IV or nonce of the cipher, in Bytes.
static mbedtls_cipher_type_t | mbedtls_cipher_get_type (const mbedtls_cipher_context_t *ctx)
| This function returns the type of the given cipher.
static const char * | mbedtls_cipher_get_name (const mbedtls_cipher_context_t *ctx)
| This function returns the name of the given cipher as a string.
static int | mbedtls_cipher_get_key_bitlen (const mbedtls_cipher_context_t *ctx)
| This function returns the key length of the cipher.
static mbedtls_operation_t | mbedtls_cipher_get_operation (const mbedtls_cipher_context_t *ctx)
| This function returns the operation of the given cipher.
int | mbedtls_cipher_setkey (mbedtls_cipher_context_t *ctx, const unsigned char *key, int key_bitlen, const mbedtls_operation_t operation)
| This function sets the key to use with the given context.
int | mbedtls_cipher_set_padding_mode (mbedtls_cipher_context_t *ctx, mbedtls_cipher_padding_t mode)
| This function sets the padding mode, for cipher modes that use padding.
int | mbedtls_cipher_set_iv (mbedtls_cipher_context_t *ctx, const unsigned char *iv, size_t iv_len)
| This function sets the initialization vector (IV) or nonce.
int | mbedtls_cipher_reset (mbedtls_cipher_context_t *ctx)
| This function resets the cipher state.
int | mbedtls_cipher_update_ad (mbedtls_cipher_context_t *ctx, const unsigned char *ad, size_t ad_len)
| This function adds additional data for AEAD ciphers. Currently supported with GCM and ChaCha20+Poly1305.
int | mbedtls_cipher_update (mbedtls_cipher_context_t *ctx, const unsigned char *input, size_t ilen, unsigned char *output, size_t *olen)
| The generic cipher update function. It encrypts or decrypts using the given cipher context. Writes as many block-sized blocks of data as possible to output. Any data that cannot be written immediately is either added to the next block, or flushed when mbedtls_cipher_finish() is called. Exception: For MBEDTLS_MODE_ECB, expects a single block in size. For example, 16 Bytes for AES.
int | mbedtls_cipher_finish (mbedtls_cipher_context_t *ctx, unsigned char *output, size_t *olen)
| The generic cipher finalization function. If data still needs to be flushed from an incomplete block, the data contained in it is padded to the size of the last block, and written to the `output` buffer.
int | mbedtls_cipher_write_tag (mbedtls_cipher_context_t *ctx, unsigned char *tag, size_t tag_len)
| This function writes a tag for AEAD ciphers. Currently supported with GCM and ChaCha20+Poly1305. This must be called after mbedtls_cipher_finish().
int | mbedtls_cipher_check_tag (mbedtls_cipher_context_t *ctx, const unsigned char *tag, size_t tag_len)
| This function checks the tag for AEAD ciphers. Currently supported with GCM and ChaCha20+Poly1305. This must be called after mbedtls_cipher_finish().
int | mbedtls_cipher_crypt (mbedtls_cipher_context_t *ctx, const unsigned char *iv, size_t iv_len, const unsigned char *input, size_t ilen, unsigned char *output, size_t *olen)
| The generic all-in-one encryption/decryption function, for all ciphers except AEAD constructs.
int | mbedtls_cipher_auth_encrypt_ext (mbedtls_cipher_context_t *ctx, const unsigned char *iv, size_t iv_len, const unsigned char *ad, size_t ad_len, const unsigned char *input, size_t ilen, unsigned char *output, size_t output_len, size_t *olen, size_t tag_len)
| The authenticated encryption (AEAD/NIST_KW) function.
int | mbedtls_cipher_auth_decrypt_ext (mbedtls_cipher_context_t *ctx, const unsigned char *iv, size_t iv_len, const unsigned char *ad, size_t ad_len, const unsigned char *input, size_t ilen, unsigned char *output, size_t output_len, size_t *olen, size_t tag_len)
| The authenticated encryption (AEAD/NIST_KW) function.

## Detailed Description

This file contains an abstraction interface for use with the cipher primitives provided by the library. It provides a common interface to all of the available cipher operations.

Author
  Adriaan de Jong dejon.nosp@m.g@fo.nosp@m.x-it..nosp@m.com

Definition in file cipher.h.

## Macro Definition Documentation

## MBEDTLS_CIPHER_MODE_AEAD

#define MBEDTLS_CIPHER_MODE_AEAD

Definition at line 25 of file cipher.h.

## MBEDTLS_CIPHER_MODE_STREAM

#define MBEDTLS_CIPHER_MODE_STREAM

Definition at line 34 of file cipher.h.

## MBEDTLS_CIPHER_MODE_WITH_PADDING

#define MBEDTLS_CIPHER_MODE_WITH_PADDING

Definition at line 29 of file cipher.h.

## MBEDTLS_CIPHER_VARIABLE_IV_LEN

#define MBEDTLS_CIPHER_VARIABLE_IV_LEN 0x01

Cipher accepts IVs of variable length.

Definition at line 52 of file cipher.h.

## MBEDTLS_CIPHER_VARIABLE_KEY_LEN

#define MBEDTLS_CIPHER_VARIABLE_KEY_LEN 0x02

Cipher accepts keys of variable length.

Definition at line 53 of file cipher.h.

## MBEDTLS_ERR_CIPHER_ALLOC_FAILED

#define MBEDTLS_ERR_CIPHER_ALLOC_FAILED -0x6180

Failed to allocate memory.

Definition at line 42 of file cipher.h.

## MBEDTLS_ERR_CIPHER_AUTH_FAILED

#define MBEDTLS_ERR_CIPHER_AUTH_FAILED -0x6300

Authentication failed (for AEAD modes).

Definition at line 48 of file cipher.h.

## MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA

#define MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA -0x6100

Bad input parameters.

Definition at line 40 of file cipher.h.

## MBEDTLS_ERR_CIPHER_FEATURE_UNAVAILABLE

#define MBEDTLS_ERR_CIPHER_FEATURE_UNAVAILABLE -0x6080

The selected feature is not available.

Definition at line 38 of file cipher.h.

## MBEDTLS_ERR_CIPHER_FULL_BLOCK_EXPECTED

#define MBEDTLS_ERR_CIPHER_FULL_BLOCK_EXPECTED -0x6280

Decryption of block requires a full block.

Definition at line 46 of file cipher.h.

## MBEDTLS_ERR_CIPHER_INVALID_CONTEXT

#define MBEDTLS_ERR_CIPHER_INVALID_CONTEXT -0x6380

The context is invalid. For example, because it was freed.

Definition at line 50 of file cipher.h.

## MBEDTLS_ERR_CIPHER_INVALID_PADDING

#define MBEDTLS_ERR_CIPHER_INVALID_PADDING -0x6200

Input data contains invalid padding and is rejected.

Definition at line 44 of file cipher.h.

## MBEDTLS_IV_SIZE_SHIFT

#define MBEDTLS_IV_SIZE_SHIFT 2

Definition at line 312 of file cipher.h.

## MBEDTLS_KEY_BITLEN_SHIFT

#define MBEDTLS_KEY_BITLEN_SHIFT 6

Definition at line 311 of file cipher.h.

## MBEDTLS_MAX_BLOCK_LENGTH

#define MBEDTLS_MAX_BLOCK_LENGTH 16

Maximum block size of any cipher, in Bytes.

Definition at line 226 of file cipher.h.

## MBEDTLS_MAX_IV_LENGTH

#define MBEDTLS_MAX_IV_LENGTH 16

Maximum length of any IV, in Bytes.

Definition at line 220 of file cipher.h.

## MBEDTLS_MAX_KEY_LENGTH

#define MBEDTLS_MAX_KEY_LENGTH 64

Maximum key length, in Bytes.

Definition at line 236 of file cipher.h.

## Typedef Documentation

## mbedtls_cipher_base_t

typedef struct mbedtls_cipher_base_t mbedtls_cipher_base_t

Base cipher information (opaque struct).

Definition at line 244 of file cipher.h.

## mbedtls_cipher_context_t

typedef struct mbedtls_cipher_context_t mbedtls_cipher_context_t

Generic cipher context.

## mbedtls_cipher_info_t

typedef struct mbedtls_cipher_info_t mbedtls_cipher_info_t

Cipher information. Allows calling cipher functions in a generic way.

Note
  The library does not support custom cipher info structures, only built-in structures returned by the functions mbedtls_cipher_info_from_string(), mbedtls_cipher_info_from_type(), mbedtls_cipher_info_from_values(), mbedtls_cipher_info_from_psa().
  Some fields store a value that has been right-shifted to save code-size, so should not be used directly. The accessor functions adjust for this and return the "natural" value.

## mbedtls_cmac_context_t

typedef struct mbedtls_cmac_context_t mbedtls_cmac_context_t

CMAC context (opaque struct).

Definition at line 249 of file cipher.h.

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
MBEDTLS_KEY_LENGTH_NONE | Undefined key length.

MBEDTLS_KEY_LENGTH_DES

Key length, in bits (including parity), for DES keys.

Warning
  DES is considered weak.

MBEDTLS_KEY_LENGTH_DES_EDE

Key length in bits, including parity, for DES in two-key EDE.

Warning
  3DES is considered weak.

MBEDTLS_KEY_LENGTH_DES_EDE3

Key length in bits, including parity, for DES in three-key EDE.

Warning
  3DES is considered weak.

Definition at line 205 of file cipher.h.

## mbedtls_cipher_id_t

enum mbedtls_cipher_id_t

Supported cipher types.

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

Enumerator
MBEDTLS_CIPHER_ID_NONE | Placeholder to mark the end of cipher ID lists.
MBEDTLS_CIPHER_ID_NULL | The identity cipher, treated as a stream cipher.
MBEDTLS_CIPHER_ID_AES | The AES cipher.

MBEDTLS_CIPHER_ID_DES

The DES cipher.

Warning
  DES is considered weak.

MBEDTLS_CIPHER_ID_3DES

The Triple DES cipher.

Warning
  3DES is considered weak.

MBEDTLS_CIPHER_ID_CAMELLIA | The Camellia cipher.
MBEDTLS_CIPHER_ID_ARIA | The Aria cipher.
MBEDTLS_CIPHER_ID_CHACHA20 | The ChaCha20 cipher.

Definition at line 66 of file cipher.h.

## mbedtls_cipher_mode_t

enum mbedtls_cipher_mode_t

Supported cipher modes.

Enumerator
MBEDTLS_MODE_NONE | None.
MBEDTLS_MODE_ECB | The ECB cipher mode.
MBEDTLS_MODE_CBC | The CBC cipher mode.
MBEDTLS_MODE_CFB | The CFB cipher mode.
MBEDTLS_MODE_OFB | The OFB cipher mode.
MBEDTLS_MODE_CTR | The CTR cipher mode.
MBEDTLS_MODE_GCM | The GCM cipher mode.
MBEDTLS_MODE_STREAM | The stream cipher mode.
MBEDTLS_MODE_CCM | The CCM cipher mode.
MBEDTLS_MODE_CCM_STAR_NO_TAG | The CCM*-no-tag cipher mode.
MBEDTLS_MODE_XTS | The XTS cipher mode.
MBEDTLS_MODE_CHACHAPOLY | The ChaCha-Poly cipher mode.
MBEDTLS_MODE_KW | The SP800-38F KW mode
MBEDTLS_MODE_KWP | The SP800-38F KWP mode

Definition at line 172 of file cipher.h.

## mbedtls_cipher_padding_t

enum mbedtls_cipher_padding_t

Supported cipher padding types.

Enumerator
MBEDTLS_PADDING_PKCS7 | PKCS7 padding (default).
MBEDTLS_PADDING_ONE_AND_ZEROS | ISO/IEC 7816-4 padding.
MBEDTLS_PADDING_ZEROS_AND_LEN | ANSI X.923 padding.
MBEDTLS_PADDING_ZEROS | Zero padding (not reversible).
MBEDTLS_PADDING_NONE | Never pad (full blocks only).

Definition at line 190 of file cipher.h.

## mbedtls_cipher_type_t

enum mbedtls_cipher_type_t

Supported {cipher type, cipher mode} pairs.

Warning
  DES/3DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

Enumerator
MBEDTLS_CIPHER_NONE | Placeholder to mark the end of cipher-pair lists.
MBEDTLS_CIPHER_NULL | The identity stream cipher.
MBEDTLS_CIPHER_AES_128_ECB | AES cipher with 128-bit ECB mode.
MBEDTLS_CIPHER_AES_192_ECB | AES cipher with 192-bit ECB mode.
MBEDTLS_CIPHER_AES_256_ECB | AES cipher with 256-bit ECB mode.
MBEDTLS_CIPHER_AES_128_CBC | AES cipher with 128-bit CBC mode.
MBEDTLS_CIPHER_AES_192_CBC | AES cipher with 192-bit CBC mode.
MBEDTLS_CIPHER_AES_256_CBC | AES cipher with 256-bit CBC mode.
MBEDTLS_CIPHER_AES_128_CFB128 | AES cipher with 128-bit CFB128 mode.
MBEDTLS_CIPHER_AES_192_CFB128 | AES cipher with 192-bit CFB128 mode.
MBEDTLS_CIPHER_AES_256_CFB128 | AES cipher with 256-bit CFB128 mode.
MBEDTLS_CIPHER_AES_128_CTR | AES cipher with 128-bit CTR mode.
MBEDTLS_CIPHER_AES_192_CTR | AES cipher with 192-bit CTR mode.
MBEDTLS_CIPHER_AES_256_CTR | AES cipher with 256-bit CTR mode.
MBEDTLS_CIPHER_AES_128_GCM | AES cipher with 128-bit GCM mode.
MBEDTLS_CIPHER_AES_192_GCM | AES cipher with 192-bit GCM mode.
MBEDTLS_CIPHER_AES_256_GCM | AES cipher with 256-bit GCM mode.
MBEDTLS_CIPHER_CAMELLIA_128_ECB | Camellia cipher with 128-bit ECB mode.
MBEDTLS_CIPHER_CAMELLIA_192_ECB | Camellia cipher with 192-bit ECB mode.
MBEDTLS_CIPHER_CAMELLIA_256_ECB | Camellia cipher with 256-bit ECB mode.
MBEDTLS_CIPHER_CAMELLIA_128_CBC | Camellia cipher with 128-bit CBC mode.
MBEDTLS_CIPHER_CAMELLIA_192_CBC | Camellia cipher with 192-bit CBC mode.
MBEDTLS_CIPHER_CAMELLIA_256_CBC | Camellia cipher with 256-bit CBC mode.
MBEDTLS_CIPHER_CAMELLIA_128_CFB128 | Camellia cipher with 128-bit CFB128 mode.
MBEDTLS_CIPHER_CAMELLIA_192_CFB128 | Camellia cipher with 192-bit CFB128 mode.
MBEDTLS_CIPHER_CAMELLIA_256_CFB128 | Camellia cipher with 256-bit CFB128 mode.
MBEDTLS_CIPHER_CAMELLIA_128_CTR | Camellia cipher with 128-bit CTR mode.
MBEDTLS_CIPHER_CAMELLIA_192_CTR | Camellia cipher with 192-bit CTR mode.
MBEDTLS_CIPHER_CAMELLIA_256_CTR | Camellia cipher with 256-bit CTR mode.
MBEDTLS_CIPHER_CAMELLIA_128_GCM | Camellia cipher with 128-bit GCM mode.
MBEDTLS_CIPHER_CAMELLIA_192_GCM | Camellia cipher with 192-bit GCM mode.
MBEDTLS_CIPHER_CAMELLIA_256_GCM | Camellia cipher with 256-bit GCM mode.

MBEDTLS_CIPHER_DES_ECB

DES cipher with ECB mode.

Warning
  DES is considered weak.

MBEDTLS_CIPHER_DES_CBC

DES cipher with CBC mode.

Warning
  DES is considered weak.

MBEDTLS_CIPHER_DES_EDE_ECB

DES cipher with EDE ECB mode.

Warning
  3DES is considered weak.

MBEDTLS_CIPHER_DES_EDE_CBC

DES cipher with EDE CBC mode.

Warning
  3DES is considered weak.

MBEDTLS_CIPHER_DES_EDE3_ECB

DES cipher with EDE3 ECB mode.

Warning
  3DES is considered weak.

MBEDTLS_CIPHER_DES_EDE3_CBC

DES cipher with EDE3 CBC mode.

Warning
  3DES is considered weak.

MBEDTLS_CIPHER_AES_128_CCM | AES cipher with 128-bit CCM mode.
MBEDTLS_CIPHER_AES_192_CCM | AES cipher with 192-bit CCM mode.
MBEDTLS_CIPHER_AES_256_CCM | AES cipher with 256-bit CCM mode.
MBEDTLS_CIPHER_AES_128_CCM_STAR_NO_TAG | AES cipher with 128-bit CCM_STAR_NO_TAG mode.
MBEDTLS_CIPHER_AES_192_CCM_STAR_NO_TAG | AES cipher with 192-bit CCM_STAR_NO_TAG mode.
MBEDTLS_CIPHER_AES_256_CCM_STAR_NO_TAG | AES cipher with 256-bit CCM_STAR_NO_TAG mode.
MBEDTLS_CIPHER_CAMELLIA_128_CCM | Camellia cipher with 128-bit CCM mode.
MBEDTLS_CIPHER_CAMELLIA_192_CCM | Camellia cipher with 192-bit CCM mode.
MBEDTLS_CIPHER_CAMELLIA_256_CCM | Camellia cipher with 256-bit CCM mode.
MBEDTLS_CIPHER_CAMELLIA_128_CCM_STAR_NO_TAG | Camellia cipher with 128-bit CCM_STAR_NO_TAG mode.
MBEDTLS_CIPHER_CAMELLIA_192_CCM_STAR_NO_TAG | Camellia cipher with 192-bit CCM_STAR_NO_TAG mode.
MBEDTLS_CIPHER_CAMELLIA_256_CCM_STAR_NO_TAG | Camellia cipher with 256-bit CCM_STAR_NO_TAG mode.
MBEDTLS_CIPHER_ARIA_128_ECB | Aria cipher with 128-bit key and ECB mode.
MBEDTLS_CIPHER_ARIA_192_ECB | Aria cipher with 192-bit key and ECB mode.
MBEDTLS_CIPHER_ARIA_256_ECB | Aria cipher with 256-bit key and ECB mode.
MBEDTLS_CIPHER_ARIA_128_CBC | Aria cipher with 128-bit key and CBC mode.
MBEDTLS_CIPHER_ARIA_192_CBC | Aria cipher with 192-bit key and CBC mode.
MBEDTLS_CIPHER_ARIA_256_CBC | Aria cipher with 256-bit key and CBC mode.
MBEDTLS_CIPHER_ARIA_128_CFB128 | Aria cipher with 128-bit key and CFB-128 mode.
MBEDTLS_CIPHER_ARIA_192_CFB128 | Aria cipher with 192-bit key and CFB-128 mode.
MBEDTLS_CIPHER_ARIA_256_CFB128 | Aria cipher with 256-bit key and CFB-128 mode.
MBEDTLS_CIPHER_ARIA_128_CTR | Aria cipher with 128-bit key and CTR mode.
MBEDTLS_CIPHER_ARIA_192_CTR | Aria cipher with 192-bit key and CTR mode.
MBEDTLS_CIPHER_ARIA_256_CTR | Aria cipher with 256-bit key and CTR mode.
MBEDTLS_CIPHER_ARIA_128_GCM | Aria cipher with 128-bit key and GCM mode.
MBEDTLS_CIPHER_ARIA_192_GCM | Aria cipher with 192-bit key and GCM mode.
MBEDTLS_CIPHER_ARIA_256_GCM | Aria cipher with 256-bit key and GCM mode.
MBEDTLS_CIPHER_ARIA_128_CCM | Aria cipher with 128-bit key and CCM mode.
MBEDTLS_CIPHER_ARIA_192_CCM | Aria cipher with 192-bit key and CCM mode.
MBEDTLS_CIPHER_ARIA_256_CCM | Aria cipher with 256-bit key and CCM mode.
MBEDTLS_CIPHER_ARIA_128_CCM_STAR_NO_TAG | Aria cipher with 128-bit key and CCM_STAR_NO_TAG mode.
MBEDTLS_CIPHER_ARIA_192_CCM_STAR_NO_TAG | Aria cipher with 192-bit key and CCM_STAR_NO_TAG mode.
MBEDTLS_CIPHER_ARIA_256_CCM_STAR_NO_TAG | Aria cipher with 256-bit key and CCM_STAR_NO_TAG mode.
MBEDTLS_CIPHER_AES_128_OFB | AES 128-bit cipher in OFB mode.
MBEDTLS_CIPHER_AES_192_OFB | AES 192-bit cipher in OFB mode.
MBEDTLS_CIPHER_AES_256_OFB | AES 256-bit cipher in OFB mode.
MBEDTLS_CIPHER_AES_128_XTS | AES 128-bit cipher in XTS block mode.
MBEDTLS_CIPHER_AES_256_XTS | AES 256-bit cipher in XTS block mode.
MBEDTLS_CIPHER_CHACHA20 | ChaCha20 stream cipher.
MBEDTLS_CIPHER_CHACHA20_POLY1305 | ChaCha20-Poly1305 AEAD cipher.
MBEDTLS_CIPHER_AES_128_KW | AES cipher with 128-bit NIST KW mode.
MBEDTLS_CIPHER_AES_192_KW | AES cipher with 192-bit NIST KW mode.
MBEDTLS_CIPHER_AES_256_KW | AES cipher with 256-bit NIST KW mode.
MBEDTLS_CIPHER_AES_128_KWP | AES cipher with 128-bit NIST KWP mode.
MBEDTLS_CIPHER_AES_192_KWP | AES cipher with 192-bit NIST KWP mode.
MBEDTLS_CIPHER_AES_256_KWP | AES cipher with 256-bit NIST KWP mode.

Definition at line 84 of file cipher.h.

## mbedtls_operation_t

enum mbedtls_operation_t

Type of operation.

Enumerator
MBEDTLS_OPERATION_NONE |
MBEDTLS_DECRYPT |
MBEDTLS_ENCRYPT |

Definition at line 199 of file cipher.h.

## Function Documentation

## mbedtls_cipher_auth_decrypt_ext()

int mbedtls_cipher_auth_decrypt_ext | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | iv,
|  | size_t | iv_len,
|  | const unsigned char * | ad,
|  | size_t | ad_len,
|  | const unsigned char * | input,
|  | size_t | ilen,
|  | unsigned char * | output,
|  | size_t | output_len,
|  | size_t * | olen,
|  | size_t | tag_len
| ) |  |

The authenticated encryption (AEAD/NIST_KW) function.

Note
  If the data is not authentic, then the output buffer is zeroed out to prevent the unauthentic plaintext being used, making this interface safer.
  For AEAD modes, the tag must be appended to the ciphertext, as recommended by RFC 5116. (NIST_KW doesn't have a separate tag.)

Parameters

  ctx | The generic cipher context. This must be initialized and bound to a key, with an AEAD algorithm or NIST_KW.
  iv | The nonce to use. This must be a readable buffer of at least `iv_len` Bytes and may be `NULL` if `iv_len` is `0`.
  iv_len | The length of the nonce. For AEAD ciphers, this must satisfy the constraints imposed by the cipher used. For NIST_KW, this must be `0`.
  ad | The additional data to authenticate. This must be a readable buffer of at least `ad_len` Bytes, and may be `NULL` is `ad_len` is `0`.
  ad_len | The length of `ad`. For NIST_KW, this must be `0`.
  input | The buffer holding the input data. This must be a readable buffer of at least `ilen` Bytes, and may be `NULL` if `ilen` is `0`.
  ilen | The length of the input data. For AEAD ciphers this must be at least `tag_len`. For NIST_KW this must be at least `8`.
  output | The buffer for the output data. This must be a writable buffer of at least `output_len` Bytes, and may be `NULL` if `output_len` is `0`.
  output_len | The length of the `output` buffer in Bytes. For AEAD ciphers, this must be at least `ilen` - `tag_len`. For NIST_KW, this must be at least `ilen` - 8.
  olen | This will be filled with the actual number of Bytes written to the `output` buffer. This must point to a writable object of type `size_t`.
  tag_len | The actual length of the authentication tag. For AEAD ciphers, this must match the constraints imposed by the cipher used, and in particular must not be `0`. For NIST_KW, this must be `0`.

Returns
  `0` on success.
  MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA on parameter-verification failure.
  MBEDTLS_ERR_CIPHER_AUTH_FAILED if data is not authentic.
  A cipher-specific error code on failure.

## mbedtls_cipher_auth_encrypt_ext()

int mbedtls_cipher_auth_encrypt_ext | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | iv,
|  | size_t | iv_len,
|  | const unsigned char * | ad,
|  | size_t | ad_len,
|  | const unsigned char * | input,
|  | size_t | ilen,
|  | unsigned char * | output,
|  | size_t | output_len,
|  | size_t * | olen,
|  | size_t | tag_len
| ) |  |

The authenticated encryption (AEAD/NIST_KW) function.

Note
  For AEAD modes, the tag will be appended to the ciphertext, as recommended by RFC 5116. (NIST_KW doesn't have a separate tag.)

Parameters

  ctx | The generic cipher context. This must be initialized and bound to a key, with an AEAD algorithm or NIST_KW.
  iv | The nonce to use. This must be a readable buffer of at least `iv_len` Bytes and may be `NULL` if `iv_len` is `0`.
  iv_len | The length of the nonce. For AEAD ciphers, this must satisfy the constraints imposed by the cipher used. For NIST_KW, this must be `0`.
  ad | The additional data to authenticate. This must be a readable buffer of at least `ad_len` Bytes, and may be `NULL` is `ad_len` is `0`.
  ad_len | The length of `ad`. For NIST_KW, this must be `0`.
  input | The buffer holding the input data. This must be a readable buffer of at least `ilen` Bytes, and may be `NULL` if `ilen` is `0`.
  ilen | The length of the input data.
  output | The buffer for the output data. This must be a writable buffer of at least `output_len` Bytes, and must not be `NULL`.
  output_len | The length of the `output` buffer in Bytes. For AEAD ciphers, this must be at least `ilen` + `tag_len`. For NIST_KW, this must be at least `ilen` + 8 (rounded up to a multiple of 8 if KWP is used); `ilen` + 15 is always a safe value.
  olen | This will be filled with the actual number of Bytes written to the `output` buffer. This must point to a writable object of type `size_t`.
  tag_len | The desired length of the authentication tag. For AEAD ciphers, this must match the constraints imposed by the cipher used, and in particular must not be `0`. For NIST_KW, this must be `0`.

Returns
  `0` on success.
  MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA on parameter-verification failure.
  A cipher-specific error code on failure.

## mbedtls_cipher_check_tag()

int mbedtls_cipher_check_tag | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | tag,
|  | size_t | tag_len
| ) |  |

This function checks the tag for AEAD ciphers. Currently supported with GCM and ChaCha20+Poly1305. This must be called after mbedtls_cipher_finish().

Parameters

  ctx | The generic cipher context. This must be initialized.
  tag | The buffer holding the tag. This must be a readable buffer of at least `tag_len` Bytes.
  tag_len | The length of the tag to check.

Returns
  `0` on success.
  A specific error code on failure.

## mbedtls_cipher_crypt()

int mbedtls_cipher_crypt | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | iv,
|  | size_t | iv_len,
|  | const unsigned char * | input,
|  | size_t | ilen,
|  | unsigned char * | output,
|  | size_t * | olen
| ) |  |

The generic all-in-one encryption/decryption function, for all ciphers except AEAD constructs.

Parameters

  ctx | The generic cipher context. This must be initialized.
  iv | The IV to use, or NONCE_COUNTER for CTR-mode ciphers. This must be a readable buffer of at least `iv_len` Bytes.
  iv_len | The IV length for ciphers with variable-size IV. This parameter is discarded by ciphers with fixed-size IV.
  input | The buffer holding the input data. This must be a readable buffer of at least `ilen` Bytes.
  ilen | The length of the input data in Bytes.
  output | The buffer for the output data. This must be able to hold at least `ilen + block_size`. This must not be the same buffer as `input`.
  olen | The length of the output data, to be updated with the actual number of Bytes written. This must not be `NULL`.

Note
  Some ciphers do not use IVs nor nonce. For these ciphers, use `iv` = NULL and `iv_len` = 0.

Returns
  `0` on success.
  MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA on parameter-verification failure.
  MBEDTLS_ERR_CIPHER_FULL_BLOCK_EXPECTED on decryption expecting a full block but not receiving one.
  MBEDTLS_ERR_CIPHER_INVALID_PADDING on invalid padding while decrypting.
  A cipher-specific error code on failure.

## mbedtls_cipher_finish()

int mbedtls_cipher_finish | ( | mbedtls_cipher_context_t * | ctx,
|  | unsigned char * | output,
|  | size_t * | olen
| ) |  |

The generic cipher finalization function. If data still needs to be flushed from an incomplete block, the data contained in it is padded to the size of the last block, and written to the `output` buffer.

Parameters

  ctx | The generic cipher context. This must be initialized and bound to a key.
  output | The buffer to write data to. This needs to be a writable buffer of at least block_size Bytes.
  olen | The length of the data written to the `output` buffer. This may not be `NULL`.

Returns
  `0` on success.
  MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA on parameter-verification failure.
  MBEDTLS_ERR_CIPHER_FULL_BLOCK_EXPECTED on decryption expecting a full block but not receiving one.
  MBEDTLS_ERR_CIPHER_INVALID_PADDING on invalid padding while decrypting.
  A cipher-specific error code on failure.

## mbedtls_cipher_free()

void mbedtls_cipher_free | ( | mbedtls_cipher_context_t * | ctx | ) |

This function frees and clears the cipher-specific context of `ctx`. Freeing `ctx` itself remains the responsibility of the caller.

Parameters

  ctx | The context to be freed. If this is `NULL`, the function has no effect, otherwise this must point to an initialized context.

## mbedtls_cipher_get_block_size()

static unsigned int mbedtls_cipher_get_block_size | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

This function returns the block size of the given cipher in bytes.

Parameters

  ctx | The context of the cipher.

Returns
  The block size of the underlying cipher.
  `1` if the cipher is a stream cipher.
  `0` if `ctx` has not been initialized.

Definition at line 678 of file cipher.h.

## mbedtls_cipher_get_cipher_mode()

static mbedtls_cipher_mode_t mbedtls_cipher_get_cipher_mode | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

This function returns the mode of operation for the cipher. For example, MBEDTLS_MODE_CBC.

Parameters

  ctx | The context of the cipher. This must be initialized.

Returns
  The mode of operation.
  MBEDTLS_MODE_NONE if `ctx` has not been initialized.

Definition at line 697 of file cipher.h.

References MBEDTLS_MODE_NONE.

## mbedtls_cipher_get_iv_size()

static int mbedtls_cipher_get_iv_size | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

This function returns the size of the IV or nonce of the cipher, in Bytes.

Parameters

  ctx | The context of the cipher. This must be initialized.

Returns
  The recommended IV size if no IV has been set.
  `0` for ciphers not using an IV or a nonce.
  The actual size if an IV has been set.

Definition at line 717 of file cipher.h.

References MBEDTLS_IV_SIZE_SHIFT.

## mbedtls_cipher_get_key_bitlen()

static int mbedtls_cipher_get_key_bitlen | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

This function returns the key length of the cipher.

Parameters

  ctx | The context of the cipher. This must be initialized.

Returns
  The key length of the cipher in bits.
  MBEDTLS_KEY_LENGTH_NONE if `ctx` has not been initialized.

Definition at line 778 of file cipher.h.

References MBEDTLS_KEY_BITLEN_SHIFT, and MBEDTLS_KEY_LENGTH_NONE.

## mbedtls_cipher_get_name()

static const char * mbedtls_cipher_get_name | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

This function returns the name of the given cipher as a string.

Parameters

  ctx | The context of the cipher. This must be initialized.

Returns
  The name of the cipher.
  NULL if `ctx` has not been not initialized.

Definition at line 759 of file cipher.h.

## mbedtls_cipher_get_operation()

static mbedtls_operation_t mbedtls_cipher_get_operation | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

This function returns the operation of the given cipher.

Parameters

  ctx | The context of the cipher. This must be initialized.

Returns
  The type of operation: MBEDTLS_ENCRYPT or MBEDTLS_DECRYPT.
  MBEDTLS_OPERATION_NONE if `ctx` has not been initialized.

Definition at line 797 of file cipher.h.

References MBEDTLS_OPERATION_NONE.

## mbedtls_cipher_get_type()

static mbedtls_cipher_type_t mbedtls_cipher_get_type | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

This function returns the type of the given cipher.

Parameters

  ctx | The context of the cipher. This must be initialized.

Returns
  The type of the cipher.
  MBEDTLS_CIPHER_NONE if `ctx` has not been initialized.

Definition at line 740 of file cipher.h.

References MBEDTLS_CIPHER_NONE.

## mbedtls_cipher_info_from_string()

const mbedtls_cipher_info_t * mbedtls_cipher_info_from_string | ( | const char * | cipher_name | ) |

This function retrieves the cipher-information structure associated with the given cipher name.

Parameters

  cipher_name | Name of the cipher to search for. This must not be `NULL`.

Returns
  The cipher information structure associated with the given `cipher_name`.
  `NULL` if the associated cipher information is not found.

## mbedtls_cipher_info_from_type()

const mbedtls_cipher_info_t * mbedtls_cipher_info_from_type | ( | const mbedtls_cipher_type_t | cipher_type | ) |

This function retrieves the cipher-information structure associated with the given cipher type.

Parameters

  cipher_type | Type of the cipher to search for.

Returns
  The cipher information structure associated with the given `cipher_type`.
  `NULL` if the associated cipher information is not found.

## mbedtls_cipher_info_from_values()

const mbedtls_cipher_info_t * mbedtls_cipher_info_from_values | ( | const mbedtls_cipher_id_t | cipher_id,
|  | int | key_bitlen,
|  | const mbedtls_cipher_mode_t | mode
| ) |  |

This function retrieves the cipher-information structure associated with the given cipher ID, key size and mode.

Parameters

  cipher_id | The ID of the cipher to search for. For example, MBEDTLS_CIPHER_ID_AES.
  key_bitlen | The length of the key in bits.
  mode | The cipher mode. For example, MBEDTLS_MODE_CBC.

Returns
  The cipher information structure associated with the given `cipher_id`.
  `NULL` if the associated cipher information is not found.

## mbedtls_cipher_info_get_block_size()

static size_t mbedtls_cipher_info_get_block_size | ( | const mbedtls_cipher_info_t * | info | ) |

inline static

This function returns the block size of the given cipher info structure in bytes.

Parameters

  info | The cipher info structure. This may be `NULL`.

Returns
  The block size of the cipher.
  `1` if the cipher is a stream cipher.
  `0` if `info` is `NULL`.

Definition at line 538 of file cipher.h.

## mbedtls_cipher_info_get_iv_size()

static size_t mbedtls_cipher_info_get_iv_size | ( | const mbedtls_cipher_info_t * | info | ) |

inline static

This function returns the size of the IV or nonce for the cipher info structure, in bytes.

Parameters

  info | The cipher info structure. This may be `NULL`.

Returns
  The recommended IV size.
  `0` for ciphers not using an IV or a nonce.
  `0` if `info` is `NULL`.

Definition at line 518 of file cipher.h.

References MBEDTLS_IV_SIZE_SHIFT.

## mbedtls_cipher_info_get_key_bitlen()

static size_t mbedtls_cipher_info_get_key_bitlen | ( | const mbedtls_cipher_info_t * | info | ) |

inline static

Retrieve the key size for a cipher info structure.

Parameters

  [in] | info | The cipher info structure to query. This may be `NULL`.

Returns
  The key length in bits. For variable-sized ciphers, this is the default length. For DES, this includes the parity bits.
  `0` if `info` is `NULL`.

Definition at line 477 of file cipher.h.

References MBEDTLS_KEY_BITLEN_SHIFT.

## mbedtls_cipher_info_get_mode()

static mbedtls_cipher_mode_t mbedtls_cipher_info_get_mode | ( | const mbedtls_cipher_info_t * | info | ) |

inline static

Retrieve the operation mode for a cipher info structure.

Parameters

  [in] | info | The cipher info structure to query. This may be `NULL`.

Returns
  The cipher mode (`MBEDTLS_MODE_xxx`).
  MBEDTLS_MODE_NONE if `info` is `NULL`.

Definition at line 456 of file cipher.h.

References MBEDTLS_MODE_NONE.

## mbedtls_cipher_info_get_name()

static const char * mbedtls_cipher_info_get_name | ( | const mbedtls_cipher_info_t * | info | ) |

inline static

Retrieve the human-readable name for a cipher info structure.

Parameters

  [in] | info | The cipher info structure to query. This may be `NULL`.

Returns
  The cipher name, which is a human readable string, with static storage duration.
  `NULL` if `info` is `NULL`.

Definition at line 498 of file cipher.h.

## mbedtls_cipher_info_get_type()

static mbedtls_cipher_type_t mbedtls_cipher_info_get_type | ( | const mbedtls_cipher_info_t * | info | ) |

inline static

Retrieve the identifier for a cipher info structure.

Parameters

  [in] | info | The cipher info structure to query. This may be `NULL`.

Returns
  The full cipher identifier (`MBEDTLS_CIPHER_xxx`).
  MBEDTLS_CIPHER_NONE if `info` is `NULL`.

Definition at line 437 of file cipher.h.

References MBEDTLS_CIPHER_NONE.

## mbedtls_cipher_info_has_variable_iv_size()

static int mbedtls_cipher_info_has_variable_iv_size | ( | const mbedtls_cipher_info_t * | info | ) |

inline static

This function returns a non-zero value if the IV size for the given cipher is variable.

Parameters

  info | The cipher info structure. This may be `NULL`.

Returns
  Non-zero if the IV size is variable, `0` otherwise.
  `0` if the given pointer is `NULL`.

Definition at line 576 of file cipher.h.

References MBEDTLS_CIPHER_VARIABLE_IV_LEN.

## mbedtls_cipher_info_has_variable_key_bitlen()

static int mbedtls_cipher_info_has_variable_key_bitlen | ( | const mbedtls_cipher_info_t * | info | ) |

inline static

This function returns a non-zero value if the key length for the given cipher is variable.

Parameters

  info | The cipher info structure. This may be `NULL`.

Returns
  Non-zero if the key length is variable, `0` otherwise.
  `0` if the given pointer is `NULL`.

Definition at line 557 of file cipher.h.

References MBEDTLS_CIPHER_VARIABLE_KEY_LEN.

## mbedtls_cipher_init()

void mbedtls_cipher_init | ( | mbedtls_cipher_context_t * | ctx | ) |

This function initializes a `ctx` as NONE.

Parameters

  ctx | The context to be initialized. This must not be `NULL`.

## mbedtls_cipher_list()

const int * mbedtls_cipher_list | ( | void |  | ) |

This function retrieves the list of ciphers supported by the generic cipher module.

For any cipher identifier in the returned list, you can obtain the corresponding generic cipher information structure via mbedtls_cipher_info_from_type(), which can then be used to prepare a cipher context via mbedtls_cipher_setup().

Returns
  A statically-allocated array of cipher identifiers of type cipher_type_t. The last entry is zero.

## mbedtls_cipher_reset()

int mbedtls_cipher_reset | ( | mbedtls_cipher_context_t * | ctx | ) |

This function resets the cipher state.

Note
  With non-AEAD ciphers, the order of calls for each message is as follows:
  1. mbedtls_cipher_set_iv() if the mode uses an IV/nonce.
  2. mbedtls_cipher_reset()
  3. mbedtls_cipher_update() one or more times
  4. mbedtls_cipher_finish()
  This sequence can be repeated to encrypt or decrypt multiple messages with the same key.
  With AEAD ciphers, the order of calls for each message is as follows:
  1. mbedtls_cipher_set_iv() if the mode uses an IV/nonce.
  2. mbedtls_cipher_reset()
  3. mbedtls_cipher_update_ad()
  4. mbedtls_cipher_update() one or more times
  5. mbedtls_cipher_finish()
  6. mbedtls_cipher_check_tag() (for decryption) or mbedtls_cipher_write_tag() (for encryption).
  This sequence can be repeated to encrypt or decrypt multiple messages with the same key.

Parameters

  ctx | The generic cipher context. This must be bound to a key.

Returns
  `0` on success.
  MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA on parameter-verification failure.

## mbedtls_cipher_set_iv()

int mbedtls_cipher_set_iv | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | iv,
|  | size_t | iv_len
| ) |  |

This function sets the initialization vector (IV) or nonce.

Note
  Some ciphers do not use IVs nor nonce. For these ciphers, this function has no effect.
  For MBEDTLS_CIPHER_CHACHA20, the nonce length must be 12, and the initial counter value is 0.
  For MBEDTLS_CIPHER_CHACHA20_POLY1305, the nonce length must be 12.

Parameters

  ctx | The generic cipher context. This must be initialized and bound to a cipher information structure.
  iv | The IV to use, or NONCE_COUNTER for CTR-mode ciphers. This must be a readable buffer of at least `iv_len` Bytes.
  iv_len | The IV length for ciphers with variable-size IV. This parameter is discarded by ciphers with fixed-size IV.

Returns
  `0` on success.
  MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA on parameter-verification failure.

## mbedtls_cipher_set_padding_mode()

int mbedtls_cipher_set_padding_mode | ( | mbedtls_cipher_context_t * | ctx,
|  | mbedtls_cipher_padding_t | mode
| ) |  |

This function sets the padding mode, for cipher modes that use padding.

Parameters

  ctx | The generic cipher context. This must be initialized and bound to a cipher information structure.
  mode | The padding mode.

Returns
  `0` on success.
  MBEDTLS_ERR_CIPHER_FEATURE_UNAVAILABLE if the selected padding mode is not supported.
  MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA if the cipher mode does not support padding.

## mbedtls_cipher_setkey()

int mbedtls_cipher_setkey | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | key,
|  | int | key_bitlen,
|  | const mbedtls_operation_t | operation
| ) |  |

This function sets the key to use with the given context.

Parameters

  ctx | The generic cipher context. This must be initialized and bound to a cipher information structure.
  key | The key to use. This must be a readable buffer of at least `key_bitlen` Bits.
  key_bitlen | The key length to use, in Bits.
  operation | The operation that the key will be used for: MBEDTLS_ENCRYPT or MBEDTLS_DECRYPT.

Returns
  `0` on success.
  MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA on parameter-verification failure.
  A cipher-specific error code on failure.

## mbedtls_cipher_setup()

int mbedtls_cipher_setup | ( | mbedtls_cipher_context_t * | ctx,
|  | const mbedtls_cipher_info_t * | cipher_info
| ) |  |

This function prepares a cipher context for use with the given cipher primitive.

Note
  After calling this function, you should call mbedtls_cipher_setkey() and, if the mode uses padding, mbedtls_cipher_set_padding_mode(), then for each message to encrypt or decrypt with this key, either:
  - mbedtls_cipher_crypt() for one-shot processing with non-AEAD modes;
  - mbedtls_cipher_auth_encrypt_ext() or mbedtls_cipher_auth_decrypt_ext() for one-shot processing with AEAD modes or NIST_KW;
  - for multi-part processing, see the documentation of mbedtls_cipher_reset().

Parameters

  ctx | The context to prepare. This must be initialized by a call to mbedtls_cipher_init() first.
  cipher_info | The cipher to use.

Returns
  `0` on success.
  MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA on parameter-verification failure.
  MBEDTLS_ERR_CIPHER_ALLOC_FAILED if allocation of the cipher-specific context fails.

## mbedtls_cipher_update()

int mbedtls_cipher_update | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | input,
|  | size_t | ilen,
|  | unsigned char * | output,
|  | size_t * | olen
| ) |  |

The generic cipher update function. It encrypts or decrypts using the given cipher context. Writes as many block-sized blocks of data as possible to output. Any data that cannot be written immediately is either added to the next block, or flushed when mbedtls_cipher_finish() is called. Exception: For MBEDTLS_MODE_ECB, expects a single block in size. For example, 16 Bytes for AES.

Parameters

  ctx | The generic cipher context. This must be initialized and bound to a key.
  input | The buffer holding the input data. This must be a readable buffer of at least `ilen` Bytes.
  ilen | The length of the input data.
  output | The buffer for the output data. This must be able to hold at least `ilen + block_size`. This must not be the same buffer as `input`.
  olen | The length of the output data, to be updated with the actual number of Bytes written. This must not be `NULL`.

Returns
  `0` on success.
  MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA on parameter-verification failure.
  MBEDTLS_ERR_CIPHER_FEATURE_UNAVAILABLE on an unsupported mode for a cipher.
  A cipher-specific error code on failure.

## mbedtls_cipher_update_ad()

int mbedtls_cipher_update_ad | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | ad,
|  | size_t | ad_len
| ) |  |

This function adds additional data for AEAD ciphers. Currently supported with GCM and ChaCha20+Poly1305.

Parameters

  ctx | The generic cipher context. This must be initialized.
  ad | The additional data to use. This must be a readable buffer of at least `ad_len` Bytes.
  ad_len | The length of `ad` in Bytes.

Returns
  `0` on success.
  A specific error code on failure.

## mbedtls_cipher_write_tag()

int mbedtls_cipher_write_tag | ( | mbedtls_cipher_context_t * | ctx,
|  | unsigned char * | tag,
|  | size_t | tag_len
| ) |  |

This function writes a tag for AEAD ciphers. Currently supported with GCM and ChaCha20+Poly1305. This must be called after mbedtls_cipher_finish().

Parameters

  ctx | The generic cipher context. This must be initialized, bound to a key, and have just completed a cipher operation through mbedtls_cipher_finish() the tag for which should be written.
  tag | The buffer to write the tag to. This must be a writable buffer of at least `tag_len` Bytes.
  tag_len | The length of the tag to write.

Returns
  `0` on success.
  A specific error code on failure.